open Instr

exception Exn of string

module P = Map.Make(String)

let prim_nb = ref 0
let prims = ref P.empty

let add p =
  try
    P.find p !prims
  with Not_found ->
    let ind = !prim_nb in
      prims := P.add p ind !prims;
      prim_nb := succ ind;
      ind
;;

let open_descriptor_out n =
  Code.add_list [
    Const n;
    Ccall (1, add "caml_ml_open_descriptor_out");
  ]
;;

let open_descriptor_in n =
  Code.add_list [
    Const n;
    Ccall (1, add "caml_ml_open_descriptor_in");
  ]
;;

let output_char fd c =
  Code.add_list [
    Const (int_of_char c);
    Push;
    Getglobal fd;
    Ccall (2, add "caml_ml_output_char");
  ]
;;

let input_char fd =
  Code.add_list [
    Getglobal fd;
    Ccall (1, add "caml_ml_input_char");
  ]
;;

let flush fd =
  Code.add_list [
    Getglobal fd;
    Ccall (1, add "caml_ml_flush");
  ]
;;

let export oc =
  let tab = Array.make !prim_nb "" in
    P.iter (fun s i -> tab.(i) <- s) !prims;
    for i = 0 to pred !prim_nb do
      Printf.fprintf oc "%s\000" tab.(i)
    done
;;
